Package: tinysnapshot
Type: Package
Title: Snapshots for Unit Tests using the 'tinytest' Framework
Version: 0.3.0
Authors@R: 
    c(person(given = "Vincent",
             family = "Arel-Bundock",
             role = c("aut", "cre"),
             email = "vincent.arel-bundock@umontreal.ca",
             comment = c(ORCID = "0000-0003-2042-7063")))
Maintainer: Vincent Arel-Bundock <vincent.arel-bundock@umontreal.ca>
Description: Snapshots for unit tests using the 'tinytest' framework for R. Includes expectations to test base R and 'ggplot2' plots as well as console output from print().
License: GPL (>= 3)
URL: https://github.com/vincentarelbundock/tinysnapshot
BugReports: https://github.com/vincentarelbundock/tinysnapshot/issues
Imports: diffobj, magick (>= 2.7.4), tinytest (>= 1.4.1)
Suggests: fontquiver, ggplot2, ragg, rsvg, svglite
Encoding: UTF-8
Config/roxygen2/version: 8.0.0
NeedsCompilation: no
Packaged: 2026-08-20 12:22:21 UTC; vincent
Author: Vincent Arel-Bundock [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-2042-7063>)
Repository: CRAN
Date/Publication: 2026-08-21 06:50:02 UTC
Built: R 4.5.2; ; 2026-08-21 08:59:39 UTC; unix

Package: tinysnapshot
Type: Package
Title: Snapshots for Unit Tests using the 'tinytest' Framework
Version: 0.2.0
Authors@R: 
    c(person(given = "Vincent",
             family = "Arel-Bundock",
             role = c("aut", "cre"),
             email = "vincent.arel-bundock@umontreal.ca",
             comment = c(ORCID = "0000-0003-2042-7063")))
Maintainer: Vincent Arel-Bundock <vincent.arel-bundock@umontreal.ca>
Description: Snapshots for unit tests using the 'tinytest' framework for R. Includes expectations to test base R and 'ggplot2' plots as well as console output from print().
License: GPL (>= 3)
URL: https://github.com/vincentarelbundock/tinysnapshot
BugReports: https://github.com/vincentarelbundock/tinysnapshot/issues
Imports: diffobj, magick (>= 2.7.4), tinytest (>= 1.4.1)
Suggests: fontquiver, ggplot2, ragg, rsvg, svglite
Encoding: UTF-8
RoxygenNote: 7.3.2
NeedsCompilation: no
Packaged: 2025-07-18 01:39:16 UTC; vincent
Author: Vincent Arel-Bundock [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-2042-7063>)
Repository: CRAN
Date/Publication: 2025-07-18 05:00:03 UTC
Built: R 4.6.0; ; 2026-04-27 04:37:49 UTC; unix

# `tinysnapshot`: Snapshots for unit tests in `R` using the `tinytest` framework.

`tinytest` is a ["lightweight, but full-featured package for unit testing in `R`"](https://cran.r-project.org/package=tinytest) created by Mark van der Loo.

`tinysnapshot` extends `tinytest` with expectations to test plots (base `R` or `ggplot2`) and `print()` output. In particular, `tinysnapshot` allows:

1. Taking snapshots of known "target" plots or `print()` output.
2. Testing if the "current" plot or `print()` output matches the target.
3. Displaying a visual "diff" to facilitate comparison when a test fails.

Under the hood, `tinysnapshot` uses [the `magick` package](https://cran.r-project.org/package=magick) by Jeroen Ooms to read and compare images, and [the `diffobj`package](https://CRAN.R-project.org/package=diffobj) by Brodie Gaslam to compare printed output.

## Installation

```r
install.packages("tinysnapshot")
```

Install the development version of `tinysnapshot`:

```r
remotes::install_github("vincentarelbundock/tinysnapshot")
```

You may also want to install additional packages to benefit from extra features:

```r
install.packages(c("rsvg", "ragg", "svglite"))
```

## Visual expectations: `expect_snapshot_plot()`

To test a visual expectation, we create an `R` script, give it a name which starts with "test", and save it in the `inst/tinytest/` directory of our package.

Each test script with visual expectations must include these two lines at the top:

```r
library("tinytest")
using("tinysnapshot")
```

When users run the `tinytest` suite, the `expect_snapshot_plot()` and `expect_snapshot_print()` expectations are executed and three main states can arise:

* On first run: 
    - Test fails and saves a visual snapshot in the `inst/tinytest/_tinysnapshot` directory.
* On subsequent runs:
    - Test passes when the plot matches the snapshot file.
    - Test fails and saves comparison files in `inst/tinytest/_tinysnapshot_review`

### `ggplot2`

In this example script, we test two `ggplot2` objects:

```r
library("ggplot2")
library("tinytest")
using("tinysnapshot")

p1 <- ggplot(mtcars, aes(mpg, wt)) + geom_point()
p2 <- ggplot(mtcars, aes(mpg, hp)) + geom_point()

# On first run: fail and save a snapshot
# On subsequent runs: pass
expect_snapshot_plot(p1, label = "ggplot2_example")

# Always fails
expect_snapshot_plot(p2, label = "ggplot2_example")
```

### Base `R` graphics

Testing a Base `R` plot is slightly different: we need to supply a function which prints the plot:

```r
library("tinytest")
using("tinysnapshot")

p1 <- function() plot(mtcars$hp, mtcars$wt)
p2 <- function() plot(mtcars$hp, mtcars$mpg)

# On first run: fail and save a snapshot
# On subsequent runs: pass
expect_snapshot_plot(p1, label = "base_example")

# Always fails
expect_snapshot_plot(p2, label = "base_example")
```

### Options and arguments

`expect_snapshot_plot` supports 4 graphics devices: `png` and `ragg` for PNG, and `svg` and `svglite` for SVG. It can set different values for the height and width of the pictures (pixels for PNG and inches for SVG). Most of the arguments can also be fixed globally using options:


```{r}
options(tinysnapshot_device = "svglite")
options(tinysnapshot_height = 7) # inches
options(tinysnapshot_width = 7)
options(tinysnapshot_tol = 200) # pixels
```

### Visual diff

When (not "if") tests fail, `tinysnapshot` will save diff files in the `inst/tinytest/_tinysnapshot_review/` folder. Diff files for plots look like this:

![](https://user-images.githubusercontent.com/987057/210011007-757b7f6d-4b57-4f77-b586-22e7d13bf9f5.png)

## Print expectations: `expect_snapshot_print()`

First, we save this script in `inst/tinytest/test-print.R`:

```r
library("tinytest")
using("tinysnapshot")

mod1 <- lm(mpg ~ hp + factor(gear), mtcars)
expect_snapshot_print(summary(mod1), label = "print-lm_summary")

mod2 <- lm(mpg ~ factor(gear), mtcars)
expect_snapshot_print(summary(mod2), label = "print-lm_summary")
```

Then, we run the tests. 

```r
tinytest::run_test_file("inst/tinytest/test-print.R")
```

The first time we run the test, it fails and saves a reference file. The second time we run it, there is already a reference text file, so only one of the tests fails. This is the expected result.

### Print diff

When tests fail, `tinytest` will return a diff like this one: 

```{r}
    test-print.R..................    2 tests 2 fails 0.3s
    ----- FAILED[]: test-print.R<12--12>
    call| expect_snapshot_print(summary(mod1), label = "print-lm_summary")
    diff| Missing reference file.
    info| diffobj::printDiff()
    ----- FAILED[]: test-print.R<15--15>
    call| expect_snapshot_print(summary(mod2), label = "print-lm_summary")
    diff| < ref                                                           
    diff| > x                                                             
    diff| @@ 1,21 / 1,20 @@                                               
    diff| 
    diff| Call:                                                         
    diff| < lm(formula = mpg ~ hp + factor(gear), data = mtcars)          
    diff| > lm(formula = mpg ~ factor(gear), data = mtcars)               
    diff| 
    diff| Residuals:                                                    
    diff| Min      1Q  Median      3Q     Max                       
    diff| < -4.4937 -2.3586 -0.8277  2.2753  7.7287                       
    diff| > -6.7333 -3.2333 -0.9067  2.8483  9.3667                       
    diff| 
    diff| Coefficients:                                                 
    diff| Estimate Std. Error t value Pr(>|t|)            
    diff| < (Intercept)   27.88193    2.10908  13.220 1.47e-13 ***        
    diff| < hp            -0.06685    0.01105  -6.052 1.59e-06 ***        
    diff| > (Intercept)     16.107      1.216  13.250 7.87e-14 ***        
    diff| < factor(gear)4  2.63486    1.55164   1.698 0.100575            
    diff| > factor(gear)4    8.427      1.823   4.621 7.26e-05 ***        
    diff| < factor(gear)5  6.57476    1.64268   4.002 0.000417 ***        
    diff| > factor(gear)5    5.273      2.431   2.169   0.0384 *          
    diff| ---                                                           
    diff| Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1
    diff| 
    diff| < Residual standard error: 3.154 on 28 degrees of freedom       
    diff| > Residual standard error: 4.708 on 29 degrees of freedom       
    diff| < Multiple R-squared:  0.7527,    Adjusted R-squared:  0.7262   
    diff| > Multiple R-squared:  0.4292,    Adjusted R-squared:  0.3898   
    diff| < F-statistic: 28.41 on 3 and 28 DF,  p-value: 1.217e-08        
    diff| > F-statistic:  10.9 on 2 and 29 DF,  p-value: 0.0002948        
    diff| 
    info| diffobj::printDiff()
    
    Warning message:
    Creating reference file: _tinysnapshot/print-lm_summary.txt 
```

When there are too many failures, `tinytest` will not always print the full diff. In those cases, you can save the `tinytest` object and print it out manually while specifying the `nlong` argument:

```r
results <- tinytest::run_test_dir()
print(results, nlong = Inf)
```

## Updating snapshots

To update the snapshot for a test, simply delete the relevant snapshot from the `inst/tinytest/_tinysnapshot` folder and run the test suite again. As when we ran the suite for the very first time, this will report a failure but generate a new snapshot.

## CRAN, continuous integration, and deterministic plots

The images produced by `R` are not *deterministic*, in the sense that they can vary slightly based on the operating system, graphics device, `R` version, etc. Unfortunately, this means that visual expectations will often fail on CRAN, where tests are run on many different platforms.

Here are some steps you can take to make testing images more portable:

1. Use the `svglite` graphics device.
2. Use a pre-defined font.
3. Run continuous integration tests on the same Operating System where you generated the original snapshot files.
4. Skip visual expectations on CRAN.

From `tinysnapshot` 0.0.3 (or using the development version from Github), many of these steps can be taken automatically by setting a few options at the top of your test scripts:

```{r}
library(tinytest)
library(tinysnapshot)
library(fontquiver)
library(svglite)
library(rsvg)
using("tinysnapshot")

options(tinysnapshot_os = "Darwin") # see Sys.info()["sysname"]
options(tinysnapshot_device = "svglite")
options(tinysnapshot_device_args = list(user_fonts = fontquiver::font_families("Liberation")))
```

Other packages [like `vdiffr`](https://vdiffr.r-lib.org/) ship with an embedded version `svglite` and their own fonts to ensure deterministic plots, but `tinysnapshot` does not do that (yet).

### CRAN multithreading warning

If your package includes lots of snapshots, you may encounter the following CRAN precheck warning:

```
Running R code in <somefile.R> had CPU time <xx> times elapsed time
```

This warning is related to multithreading, since CRAN wishes to avoid excessive use of CPU resources by any one package during compilation and testing. (See this [R-devel thread](https://stat.ethz.ch/pipermail/r-package-devel/2023q3/009513.html) for details.) In the case of `tinysnapshot`, the warning can arise due to our dependency on `magick`, which automatically invokes multithreading behind the scenes. A simple [solution](https://github.com/vincentarelbundock/tinysnapshot/issues/13) is thus to turn off `magick`'s multithreading behaviour during CRAN checks. For example, by adding the following code chunk to the top of your `tests/tinytest.R` file. 

```r
# Throttle magick CPU threads if R CMD check (for CRAN)
if (any(grepl("_R_CHECK", names(Sys.getenv()), fixed = TRUE))) {
    if (requireNamespace("magick", quietly = TRUE)) {
        library(magick)
        magick:::magick_threads(1)
    }
}
```

## Minimal package example

We now create a minimal `R` package to illustrate how to use `tinysnapshot` in the "real world."

Create a `temp` directory and use the `pkgKitten` package to create an ultra-minimalist package (an alternative would be the `usethis` package):

```r
library(tinytest)
library(pkgKitten)
kitten(name = "testpkg")
```
```r
    Creating directories ...
    Creating DESCRIPTION ...
    Creating NAMESPACE ...
    Adding pkgKitten overrides.
    >> added .gitignore file
    >> added .Rbuildignore file
    >> added tinytest support

    Consider reading the documentation for all the packaging details.
    A good start is the 'Writing R Extensions' manual.

    And run 'R CMD check'. Run it frequently. And think of those kittens.
```

Download an example test script from the `tinysnapshot` repository:

```r
download.file(
    url = "https://raw.githubusercontent.com/vincentarelbundock/tinysnapshot/main/inst/tinytest/test-png.R",
    destfile = "testpkg/inst/tinytest/test-png.R",
    quiet = TRUE)
```

Our package now includes 7 tests: 1 created by default by the `puppy()` function, and 6 tests in the `test-png.R` script. When we run `tinytest` the first time, the 6 `test-png.R` tests fail, but some generate snapshots in PNG format:

```r
setwd("testpkg")
tinytest::run_test_dir("inst/tinytest")
```
```r
    test_testpkg.R................    1 tests OK 22ms
    test-png.R..................    6 tests 6 fails 0.8s
    ----- FAILED[]: test-png.R<15--15>
    call| expect_snapshot_plot(p1, "base")
    diff| 0
    info| pixels
    ----- FAILED[]: test-png.R<18--18>
    call| **expect_snapshot_plot**(p2, "base")
    diff| 3232
    info| pixels
    ----- FAILED[]: test-png.R<25--25>
    call| expect_snapshot_plot(p1, "ggplot2_variable")
    diff| 0
    info| pixels
    FAILED[]: test-png.R<28--28> expect_snapshot_plot(p2, "ggplot2_variable")
    FAILED[]: test-png.R<31--31> expect_snapshot_plot(p3, "ggplot2_theme")
    FAILED[]: test-png.R<34--34> expect_snapshot_plot(p4, "ggplot2_theme")
    
    Showing 6 out of 7 results: 6 fails, 1 passes (0.8s)
    Warning messages:
    1: Creating reference file: _tinysnapshot/base.png 
    2: Creating reference file: _tinysnapshot/ggplot2_variable.png 
    3: Creating reference file: _tinysnapshot/ggplot2_theme.png 
```

The second time we run the test suite, only 3 of the `test-png.R` tests fail:

```r
tinytest::run_test_dir("inst/tinytest")
```

```r
    test_testpkg.R................    1 tests OK 6ms
    test-png.R....................    6 tests 3 fails 0.6s
    ----- FAILED[]: test-png.R<18--18>
    call| expect_snapshot_plot(p2, "base")
    diff| 3232
    info| pixels
    ----- FAILED[]: test-png.R<28--28>
    call| expect_snapshot_plot(p2, "ggplot2_variable")
    diff| 33536
    info| pixels
    ----- FAILED[]: test-png.R<34--34>
    call| expect_snapshot_plot(p4, "ggplot2_theme")
    diff| 191955
    info| pixels
    
    Showing 3 out of 7 results: 3 fails, 4 passes (0.7s)
```

source("helpers.R")

# 1st run: These tests fail 6 times and generate 3 reference plots
# 2nd run: These tests fail 3 times
library("tinytest")
using("tinysnapshot")
options(tinysnapshot_device = "ragg")

###### base R
p1 <- function() plot(mtcars$hp, mtcars$mpg)
p2 <- function() plot(mtcars$hp, mtcars$wt)

# good plot
# Run once to create the reference plot
# Run twice to pass the test
expect_snapshot_plot(p1, "ragg-base")

# bad plot always fails
if (
  Sys.info()["sysname"] %in%
    getOption("tinysnapshot_os", default = Sys.info()["sysname"])
) {
  expect_false(ignore(expect_snapshot_plot)(p2, "ragg-base", review = FALSE))
}

###### ggplot2
suppressPackageStartupMessages(library("ggplot2"))

p1 <- ggplot(mtcars, aes(mpg, hp)) +
  geom_point()
expect_snapshot_plot(p1, "ragg-ggplot2_variable")

p2 <- ggplot(mtcars, aes(mpg, wt)) +
  geom_point()
if (
  Sys.info()["sysname"] %in%
    getOption("tinysnapshot_os", default = Sys.info()["sysname"])
) {
  expect_false(ignore(expect_snapshot_plot)(
    p2,
    "ragg-ggplot2_variable",
    review = FALSE
  ))
}


options(tinysnapshot_device = NULL)

source("helpers.R")
using("tinysnapshot")

options(tinysnapshot_device = "svglite")

if (!SKIP) {
  p1 <- function() plot(mtcars$hp, mtcars$mpg)
  flag <- expect_snapshot_plot(p1, "svglite-base")
  expect_inherits(flag, "tinytest")
}

options(tinysnapshot_device = NULL)
options(tinysnapshot_os = NULL)

.onLoad = function(libname, pkgname) {
  tinytest::register_tinytest_extension(
    "tinysnapshot",
    c(
      "expect_equivalent_images",
      "expect_snapshot_plot",
      "expect_snapshot_print"
    )
  )
}

rm(list = ls())
OSes <- c("Darwin")
options(width = 10000)
options(tinysnapshot_os = OSes)
# Small tolerance to absorb antialiasing drift across macOS versions: the
# Quartz `png` device renders slightly differently on macOS 15 vs 26. Genuine
# plot differences are ~1e-2, two orders of magnitude above this threshold.
options(tinysnapshot_tol = 1e-4)

ON_CRAN <- !identical(Sys.getenv("NOT_CRAN"), "true")
BAD_OS <- !Sys.info()[["sysname"]] %in% OSes
SKIP <- ON_CRAN || BAD_OS

source("helpers.R")

# 1st run: These tests fail 6 times and generate 3 reference plots
# 2nd run: These tests fail 3 times
library("tinytest")
using("tinysnapshot")
options(tinysnapshot_device = "svg")

###### base R
p1 <- function() plot(mtcars$hp, mtcars$mpg)
p2 <- function() plot(mtcars$hp, mtcars$wt)

# good plot
# Run once to create the reference plot
# Run twice to pass the test
expect_snapshot_plot(p1, "svg-base")

# bad plot always fails
if (!SKIP) {
  expect_false(ignore(expect_snapshot_plot)(p2, "svg-base", review = FALSE))
}

###### ggplot2
suppressPackageStartupMessages(library("ggplot2"))

p1 <- ggplot(mtcars, aes(mpg, hp)) +
  geom_point()
expect_snapshot_plot(p1, "svg-ggplot2_variable")

p2 <- ggplot(mtcars, aes(mpg, wt)) +
  geom_point()

if (!SKIP) {
  expect_false(ignore(expect_snapshot_plot)(
    p2,
    "svg-ggplot2_variable",
    review = FALSE
  ))
}


options(tinysnapshot_device = NULL)

snapshot_label <- function(label) {
  regex <- "[^[:alnum:]|_|-]"
  regexdot <- "[^[:alnum:]_|\\-|\\.]"
  out <- gsub(regexdot, "_", label, perl = TRUE)
  return(out)
}

ts_assert_package <- function(package) {
  flag <- requireNamespace(package, quietly = TRUE)
  if (isFALSE(flag)) {
    msg <- sprintf("Please install the `%s` package.", package)
    stop(msg, call. = FALSE)
  }
}

ts_assert_choice <- function(x, choices) {
  flag <- is.character(x) &&
    length(x) == 1 &&
    x %in% choices
  if (!flag) {
    msg <- sprintf(
      "Invalid value. Must be one of: %s",
      paste(sprintf('"%s"', choices), collapse = ", ")
    )
    stop(msg, call. = FALSE)
  }
}

ts_assert_number <- function(x, lower = -Inf, upper = Inf) {
  flag <- is.numeric(x) &&
    length(x) == 1 &&
    x >= lower &&
    x <= upper
  if (!flag) {
    msg <- sprintf(
      "Invalid value. Must be a single number between %s and %s.",
      lower,
      upper
    )
    stop(msg, call. = FALSE)
  }
}

ts_assert_file_exists <- function(x) {
  if (!is.character(x) || length(x) != 1) {
    stop("Invalid file name.", call. = FALSE)
  }
  if (!file.exists(x)) {
    msg <- sprintf("Missing file: %s", x)
    stop(msg, call. = FALSE)
  }
}

ts_assert_named_list <- function(x, null.ok = FALSE) {
  if (is.null(x) && null.ok) {
    return(invisible(NULL))
  }
  if (!is.list(x) || is.null(names(x))) {
    stop("Must be a named list.", call. = FALSE)
  }
}

ts_check_file_exists <- function(x) {
  if (!is.character(x) || length(x) != 1 || !file.exists(x)) {
    FALSE
  } else {
    TRUE
  }
}

ts_prepend_info <- function(user_info, internal_info) {
  if (is.null(user_info)) return(internal_info)
  if (is.na(internal_info)) return(user_info)
  paste(user_info, internal_info, sep = "\n")
}

ts_assert_path_for_output <- function(x) {
  if (!is.character(x) || length(x) != 1) {
    stop("Invalid path.", call. = FALSE)
  }
  #    # This doesn't work
  #    if (file.access(x, mode = 2) != 0) {
  #        msg <- sprintf("Path not writeable: %s", x)
  #        stop(msg, call. = FALSE)
  #    }
}

source("helpers.R")

# 1st run: These tests fail 6 times and generate 3 reference plots
# 2nd run: These tests fail 3 times
library("tinytest")
using("tinysnapshot")
options(tinysnapshot_device = "svglite")

###### base R
p1 <- function() plot(mtcars$hp, mtcars$mpg)
p2 <- function() plot(mtcars$hp, mtcars$wt)

# good plot
# Run once to create the reference plot
# Run twice to pass the test
expect_snapshot_plot(p1, "svglite-base")

# bad plot always fails
if (
  Sys.info()["sysname"] %in%
    getOption("tinysnapshot_os", default = Sys.info()["sysname"])
) {
  expect_false(ignore(expect_snapshot_plot)(p2, "svglite-base", review = FALSE))
}

###### ggplot2
suppressPackageStartupMessages(library("ggplot2"))

p1 <- ggplot(mtcars, aes(mpg, hp)) +
  geom_point()
expect_snapshot_plot(p1, "svglite-ggplot2_variable")

if (
  Sys.info()["sysname"] %in%
    getOption("tinysnapshot_os", default = Sys.info()["sysname"])
) {
  p2 <- ggplot(mtcars, aes(mpg, wt)) +
    geom_point()
  expect_false(ignore(expect_snapshot_plot)(
    p2,
    "svglite-ggplot2_variable",
    review = FALSE
  ))
}


options(tinysnapshot_device = NULL)

source("helpers.R")

# 1st run: These tests fail 2 times and generate 1 reference text file
# 2nd run: These tests fail 1 time
library("tinytest")
using("tinysnapshot")

mod1 <- lm(mpg ~ hp + factor(gear), mtcars)
mod2 <- lm(mpg ~ factor(gear), mtcars)

# First run fails
# Second run passes
expect_snapshot_print(summary(mod1), "print-lm_summary")

# Always fails
if (!SKIP) {
  expect_false(ignore(expect_snapshot_print)(summary(mod2), "print-lm_summary"))
}


# Use fn_*() to remove random string from snapshot
# Do NOT set a seed for this
set.seed(NULL)
x <- paste0("blah_", sample(1:1e6, 1))
fn <- function(x) sub("_.*", "", x)
expect_snapshot_print(
  x,
  label = "print-sub_label_fn",
  fn_current = fn,
  fn_target = fn
)

#' Test if printed output matches a target printout
#'
#' @description
#' This expectation can be used with `tinytest` to check if the new plot matches
#' a target plot.
#'
#' When the expectation is checked for the first time, the expectation fails and
#' a reference text file is saved to the `inst/tinytest/_tinysnapshot` folder.
#'
#' To update a snapshot, delete the reference file from the `_tinysnapshot`
#' folder and run the test suite again.
#'
#' See the package README file or website for detailed examples.
#'
#' @param current an object which returns text to the console when calling `print(x`)`
#' @param info a string with user-supplied context shown when the test fails, prepended to the internal message.
#' @param mode "unified", "sidebyside", "context", or "auto". See `?diffobj::diffPrint`
#' @param format "raw", "ansi8", "ansi256", "html", or "auto". See `?diffobj::diffPrint`
#' @param ignore_white_space `TRUE` to ignore horizontal white space and empty lines.
#' @param fn_current A function to apply to the current output before comparison.
#' @param fn_target A function to apply to the target output before comparison.
#' @inheritParams expect_snapshot_plot
#' @param ... Additional arguments are passed to `diffobj::diffPrint()`
#' @return A `tinytest` object. A `tinytest` object is a `logical` with attributes holding information about the test that was run
#' @export
expect_snapshot_print <- function(
  current,
  label,
  info = NULL,
  mode = getOption("tinysnapshot_mode", default = "unified"),
  format = getOption("tinysnapshot_format", default = "ansi256"),
  ignore_white_space = getOption(
    "tinysnapshot_ignore_white_space",
    default = FALSE
  ),
  fn_current = getOption("tinysnapshot_fn_current", default = identity),
  fn_target = getOption("tinysnapshot_fn_target", default = identity),
  ...
) {
  # defaults
  snapshot <- snapshot_label(label)
  snapshot_fn <- file.path("_tinysnapshot", snapshot)
  if (isTRUE(tools::file_ext(snapshot) == "")) {
    snapshot_fn <- paste0(snapshot_fn, ".txt")
  }
  cal <- sys.call(sys.parent(1))
  diff <- msg <- NA_character_
  fail <- FALSE

  stopifnot(is.function(fn_current))
  stopifnot(is.function(fn_target))

  # if snapshot missing, copy current to snapshot, and return failure immediately
  if (!isTRUE(ts_check_file_exists(snapshot_fn))) {
    if (isTRUE(tinytest::at_home())) {
      dir.create(dirname(snapshot_fn), showWarnings = FALSE, recursive = TRUE)
      sink(snapshot_fn)
      print(current)
      sink()
      msg <- paste("Creating snapshot:", snapshot_fn)
    } else {
      # stop() otherwise source("test-file.R") fails silently
      msg <- "Snapshot missing: %s. Make sure you execute commands in the right directory, or use one of the `tinytest` runners to generate new snapshots: `run_test_dir()` or `run_test_file()`."
      msg <- sprintf(msg, snapshot_fn)
      stop(msg, call. = FALSE)
    }
    return(tinytest::tinytest(FALSE, call = cal, info = ts_prepend_info(info, msg)))
  }

  # snapshot exists -> diff
  print.tinysnapshotprint <- function(x) cat(x)
  target <- readLines(snapshot_fn, warn = FALSE)
  target <- paste(target, collapse = "\n")
  current <- paste(utils::capture.output(print(current)), collapse = "\n")

  strip <- function(x) {
    out <- strsplit(x, "\n")[[1]]
    out <- sapply(out, trimws)
    out <- out[out != ""]
    paste(out, collapse = "\n")
  }
  if (isTRUE(ignore_white_space)) {
    target <- strip(target)
    current <- strip(current)
  }

  target <- fn_target(target)
  current <- fn_current(current)

  class(target) <- c("tinysnapshotprint", class(target))
  class(current) <- c("tinysnapshotprint", class(current))

  diff_args <- c(
    list(
      current = current,
      target = target,
      mode = mode,
      format = format,
      guides = FALSE,
      sgr.supported = TRUE,
      strip.sgr = FALSE
    ),
    list(...)
  )
  diff_args[["ignore.white.space"]] <- ignore_white_space
  do <- suppressWarnings(do.call(diffobj::diffPrint, diff_args))

  if (suppressWarnings(any(do))) {
    fail <- TRUE
    diff <- paste(as.character(do), collapse = "\n")
    msg <- paste("Snapshot:", snapshot_fn)
  }

  tinytest::tinytest(
    result = !fail,
    call = cal,
    info = ts_prepend_info(info, msg),
    diff = diff
  )
}

#' Test if the new plot matches a target (snapshot) plot
#'
#' @description
#' This expectation can be used with `tinytest` to check if the new plot matches
#' a target plot.
#'
#' When the expectation is checked for the first time, the expectation fails and
#' a reference plot is saved to the `inst/tinytest/_tinysnapshot` folder.
#'
#' When the expectation fails, the reference plot, the new plot, and a diff are
#' saved to the `inst/tinytest/label` folder. Call the `review()` function to compare.
#'
#' To update a snapshot, delete the reference file from the `_tinysnapshot`
#' folder and run the test suite again.
#'
#' See the package README file or website for detailed examples.
#'
#' @param current an object of class `ggplot` or a function which returns a base R plot.
#' @param label a string to identify the snapshot (alpha-numeric, hyphens, or underscores). Each plot in the test suite must have a unique label.
#' @param width of the snapshot. PNG default: 480 pixels. SVG default: 7 inches.
#' @param height of the snapshot. PNG default: 480 pixels. SVG default: 7 inches.
#' @param device "svg", "png", "ragg" or "svglite"
#' @param device_args list of arguments to pass to the device call (e.g., `user_fonts` for `svglite` device).
#' @param par_args named list of arguments to pass to `graphics::par()` for setting graphical parameters. Only used when `device` is "png" or "ragg". Default is `NULL`.
#' @param theme a `ggplot2` theme function. `NULL` (default) uses `ggplot2::theme_test()`.
#' @param tol distance estimates larger than this threshold will trigger a test failure. Scale depends on the `metric` argument. With the default `metric="AE"` (absolute error), the `tolerance` corresponds roughly to the number of pixels of difference between the plot and the reference image.
#' @param metric string with a metric from `magick::metric_types()` such as `"AE"` or `"phash"`.
#' @param fuzz relative color distance between 0 and 100 to be considered similar.
#' @param style A character vector to control the panels of the diff image saved to file. The order and number of entries controls the side-by-side panels. Allowable values are: "old", "new", "diff".
#' @param review logical. TRUE if a a diff plot should be saved to file for review when the expectation fails.
#' @param os character vector of operating systems on which the test should be run (e.g., "Windows", "Linux", "Darwin"). Tests are skipped when no element of the vector matches the output of: `Sys.info()["sysname"]`
#' @param skip logical. If TRUE, the test is skipped (with a message). Default: TRUE when the session is not interactive and neither the `NOT_CRAN` nor the `R_COVR` environment variable is set to "true".
#' @param info a string with user-supplied context shown when the test fails, prepended to the internal message.
#' @return A `tinytest` object. A `tinytest` object is a `logical` with attributes holding information about the test that was run
#'
#' @export
expect_snapshot_plot <- function(
    current,
    label,
    width = getOption("tinysnapshot_width", default = NULL),
    height = getOption("tinysnapshot_height", default = NULL),
    tol = getOption("tinysnapshot_tol", default = 0),
    metric = getOption("tinysnapshot_metric", default = "AE"),
    fuzz = getOption("tinysnapshot_fuzz", default = 0),
    device = getOption("tinysnapshot_device", default = "svg"),
    device_args = getOption("tinysnapshot_device_args", default = list()),
    par_args = getOption("tinysnapshot_par_args", default = NULL),
    theme = getOption("tinysnapshot_theme", default = NULL),
    style = getOption("tinysnapshot_plot_diff_style", default = c("old", "new", "diff")),
    review = getOption("tinysnapshot_plot_review", default = TRUE),
    os = getOption("tinysnapshot_os", default = Sys.info()["sysname"]),
    skip = getOption(
      "tinysnapshot_plot_skip",
      default = !interactive() &&
        !identical(Sys.getenv("NOT_CRAN"), "true") &&
        !identical(Sys.getenv("R_COVR"), "true")
    ),
    info = NULL) {
  ts_assert_choice(device, c("ragg", "png", "svg", "svglite"))
  if (!is.null(theme) && !is.function(theme)) {
    stop("`theme` must be NULL or an unevaluated function.", call. = FALSE)
  }

  cal <- sys.call(sys.parent(1))

  if (!isTRUE(is.vector(os)) || !isTRUE(is.character(os))) {
    stop("`os` must be a character vector.", call. = FALSE)
  }

  if (!isTRUE(skip) && !isFALSE(skip)) {
    stop("`skip` must be `TRUE` or `FALSE`.", call. = FALSE)
  }

  if (!Sys.info()["sysname"] %in% os || skip) {
    if (skip) {
      msg <- "Skipping snapshot test `%s`: the session is not interactive and neither the `NOT_CRAN` nor the `R_COVR` environment variable is set to \"true\". Set `options(tinysnapshot_plot_skip = FALSE)` or the `skip` argument to force the test to run."
    } else {
      msg <- "Skipping snapshot test `%s`: the operating system does not match the `os` argument."
    }
    message(sprintf(msg, label))
    return(invisible(NULL))
  }

  # defaults
  snapshot <- snapshot_label(label)
  cal <- sys.call(sys.parent(1))
  if (device %in% c("png", "ragg")) {
    ext <- ".png"
    if (is.null(width)) {
      width <- 480
    }
    if (is.null(height)) height <- width
  } else if (device %in% c("svg", "svglite")) {
    ext <- ".svg"
    if (is.null(width)) {
      width <- 7
    }
    if (is.null(height)) height <- width
  }
  current_fn <- paste0(tempfile(), ext)
  snapshot_fn <- file.path("_tinysnapshot", paste0(snapshot, ext))

  if (!is.function(current) && !inherits(current, "ggplot")) {
    msg <- "`current` must be a `ggplot2` object or a function which returns a base `R` plot."
    return(tinytest::tinytest(FALSE, call = cal, info = ts_prepend_info(info, msg)))
  }

  device_args[["filename"]] <- current_fn
  device_args[["width"]] <- width
  device_args[["height"]] <- height

  # write current plot to file
  if (device == "ragg") {
    ts_assert_package("ragg")
    do.call(ragg::agg_png, device_args)
  } else if (device == "png") {
    do.call(grDevices::png, device_args)
  } else if (device == "svglite") {
    # need rsvg otherwise magick returns all white images
    ts_assert_package("rsvg")
    ts_assert_package("svglite")
    do.call(svglite::svglite, device_args)
  } else if (device == "svg") {
    # need rsvg otherwise magick returns all white images
    ts_assert_package("rsvg")
    do.call(grDevices::svg, device_args)
  }

  ts_assert_named_list(par_args, null.ok = TRUE)
  if (length(par_args) > 0 && device %in% c("png", "ragg")) {
    do.call(graphics::par, par_args)
  }

  if (inherits(current, "ggplot")) {
    ts_assert_package("ggplot2")
    if (is.null(theme)) {
      print(current + ggplot2::theme_test())
    } else if (is.function(theme)) {
      print(current + theme())
    } else {
    }
  } else {
    current()
  }
  invisible(grDevices::dev.off())

  # if snapshot missing, copy current to snapshot, and return failure immediately
  if (!isTRUE(ts_check_file_exists(snapshot_fn))) {
    if (isTRUE(tinytest::at_home())) {
      dir.create(dirname(snapshot_fn), recursive = TRUE, showWarnings = FALSE)
      file.copy(from = current_fn, to = snapshot_fn)
      msg <- paste("Creating snapshot:", snapshot_fn)
    } else {
      # stop() otherwise source("test-file.R") fails silently
      msg <- "Snapshot missing: %s. Make sure you execute commands in the right directory, or use one of the `tinytest` runners to generate new snapshots: `run_test_dir()` or `run_test_file()`."
      msg <- sprintf(msg, snapshot_fn)
      stop(msg, call. = FALSE)
    }
    return(tinytest::tinytest(FALSE, call = cal, info = ts_prepend_info(info, msg)))
  }

  # if snapshot present -> compare images and save diff plot
  dir.create("_tinysnapshot_review", recursive = TRUE, showWarnings = FALSE)
  out <- expect_equivalent_images(
    current_fn,
    snapshot_fn,
    tol = tol,
    metric = metric,
    fuzz = fuzz,
    style = style,
    review = review,
    diffpath = file.path(
      "_tinysnapshot_review",
      paste0(basename(snapshot), ".png")
    )
  )
  attr(out, "call") <- cal
  if (!is.null(info)) {
    attr(out, "info") <- ts_prepend_info(info, attr(out, "info"))
  }
  return(out)
}


#' Test if two image files are equivalent
#'
#' @param current path to an image file
#' @param target path to an image file
#' @param diffpath path where to save an image which shows the differences between `current` and `target`. `NULL` means that the diff image is not saved.
#' @inheritParams expect_snapshot_plot
#' @return A `tinytest` object. A `tinytest` object is a `logical` with attributes holding information about the test that was run
#' @export
expect_equivalent_images <- function(
    current,
    target,
    tol = getOption("tinysnapshot_tol", default = 0),
    metric = getOption("tinysnapshot_metric", default = "AE"),
    fuzz = getOption("tinysnapshot_fuzz", default = 0),
    style = getOption(
      "tinysnapshot_plot_diff_style",
      default = c("old", "new", "diff")
    ),
    review = getOption("tinysnapshot_plot_review", default = TRUE),
    diffpath = NULL) {
  # default values
  cal <- sys.call(sys.parent(1))
  info <- diff <- NA_character_
  fail <- FALSE

  # input sanity checks
  if (
    !is.character(style) ||
      length(style) < 1 ||
      length(style) > 3 ||
      any(!style %in% c("old", "new", "diff")) ||
      any(duplicated(style))
  ) {
    stop(
      "style must be a character vector of length 1, 2, or 3, containing 'old', 'new', 'diff' with no duplicates."
    )
  }

  ts_assert_choice(metric, choices = magick::metric_types())
  ts_assert_number(tol, lower = 0)
  ts_assert_number(fuzz, lower = 0)
  ts_assert_file_exists(current)
  ts_assert_file_exists(target)
  if (!is.null(diffpath)) {
    ts_assert_path_for_output(diffpath)
  }

  # distance > tol
  if (tools::file_ext(target) == "svg") {
    file_target <- magick::image_read_svg(target)
    file_current <- magick::image_read_svg(current)
  } else {
    file_target <- suppressWarnings(magick::image_read(target))
    file_current <- suppressWarnings(magick::image_read(current))
  }
  dis <- magick::image_compare_dist(
    file_target,
    file_current,
    metric = metric,
    fuzz = fuzz
  )
  dis <- unname(dis$distortion)
  info <- paste("Distance metric:", metric)
  diff <- as.character(dis)
  if (dis > tol) {
    fail <- TRUE
  }

  # diff plot
  if (isTRUE(review) && isTRUE(fail) && !is.null(diffpath)) {
    diffplot <- magick::image_compare(
      file_current,
      file_target,
      metric = metric,
      fuzz = fuzz
    )

    images <- list(
      old = grDevices::as.raster(file_target),
      new = grDevices::as.raster(file_current),
      diff = grDevices::as.raster(diffplot)
    )

    width <- sum(sapply(images[style], nrow))
    height <- max(sapply(images[style], ncol))

    grDevices::png(diffpath, width = width, height = height)
    def_par <- graphics::par(no.readonly = TRUE) # save graphics params
    graphics::par(mfrow = c(1, length(style)), mar = rep(0, 4))

    for (s in style) {
      plot(images[[s]])
    }

    # close device and reset graphics parameters
    invisible(grDevices::dev.off())
    graphics::par(def_par)

    info <- paste("Diff plot saved to:", diffpath)
  }

  # test results
  tinytest::tinytest(
    result = !fail,
    call = cal,
    info = info,
    diff = diff
  )
}

source("helpers.R")

# 1st run: These tests fail 6 times and generate 3 reference plots
# 2nd run: These tests fail 3 times
library("tinytest")
using("tinysnapshot")
options(tinysnapshot_device = "png")

###### base R
p1 <- function() plot(mtcars$hp, mtcars$mpg)
p2 <- function() plot(mtcars$hp, mtcars$wt)

# good plot
# Run once to create the reference plot
# Run twice to pass the test
expect_snapshot_plot(p1, "png-base")

# bad plot always fails
if (!SKIP) {
  expect_false(ignore(expect_snapshot_plot)(p2, "png-base", review = FALSE))
}

###### ggplot2
suppressPackageStartupMessages(library("ggplot2"))

p1 <- ggplot(mtcars, aes(mpg, hp)) +
  geom_point()
expect_snapshot_plot(p1, "png-ggplot2_variable")

p2 <- ggplot(mtcars, aes(mpg, wt)) +
  geom_point()
if (!SKIP) {
  expect_false(ignore(expect_snapshot_plot)(
    p2,
    "png-ggplot2_variable",
    review = FALSE
  ))
}

p3 <- ggplot(mtcars, aes(mpg, hp)) +
  geom_point()
expect_snapshot_plot(
  p3,
  "png-ggplot2_theme_dark",
  theme = ggplot2::theme_dark
)

# test expect_equivalent_images ever so briefly
pf1 <- tempfile(fileext = ".png")
pf2 <- tempfile(fileext = ".png")
pf3 <- tempfile(fileext = ".png")
set.seed(123)
D <- data.frame(x = 1:100, y = cumsum(rnorm(100)))

png(pf1)
with(D, plot(x, y, type = "l", main = "Plot One"))
dev.off()

png(pf2)
with(D, plot(x, y, type = "l", main = "Plot Two", xlab = "Foo"))
dev.off()

# plots differ so expect false result
expect_false(ignore(expect_equivalent_images)(
  pf1,
  pf2,
  diffpath = pf3,
  review = FALSE
))
expect_false(ignore(expect_equivalent_images)(
  pf1,
  pf2,
  diffpath = pf3,
  style = "diff",
  review = FALSE
))
expect_false(ignore(expect_equivalent_images)(
  pf1,
  pf2,
  diffpath = pf3,
  style = c("old", "new", "diff"),
  review = FALSE
))

# wrong arguments
expect_error(expect_equivalent_images(
  pf1,
  pf2,
  diffpath = pf3,
  style = "multiple"
))
options(tinysnapshot_plot_diff_style = "wrong argument")
expect_error(expect_equivalent_images(pf1, pf2, diffpath = pf3))

options(tinysnapshot_device = NULL)
options(tinysnapshot_plot_diff_style = "three")

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/expect_snapshot_plot.R
\name{expect_snapshot_plot}
\alias{expect_snapshot_plot}
\title{Test if the new plot matches a target (snapshot) plot}
\usage{
expect_snapshot_plot(
  current,
  label,
  width = getOption("tinysnapshot_width", default = NULL),
  height = getOption("tinysnapshot_height", default = NULL),
  tol = getOption("tinysnapshot_tol", default = 0),
  metric = getOption("tinysnapshot_metric", default = "AE"),
  fuzz = getOption("tinysnapshot_fuzz", default = 0),
  device = getOption("tinysnapshot_device", default = "svg"),
  device_args = getOption("tinysnapshot_device_args", default = list()),
  par_args = getOption("tinysnapshot_par_args", default = NULL),
  theme = getOption("tinysnapshot_theme", default = NULL),
  style = getOption("tinysnapshot_plot_diff_style", default = c("old", "new", "diff")),
  review = getOption("tinysnapshot_plot_review", default = TRUE),
  os = getOption("tinysnapshot_os", default = Sys.info()["sysname"]),
  skip = getOption("tinysnapshot_plot_skip", default = !interactive() &&
    !identical(Sys.getenv("NOT_CRAN"), "true") && !identical(Sys.getenv("R_COVR"),
    "true")),
  info = NULL
)
}
\arguments{
\item{current}{an object of class \code{ggplot} or a function which returns a base R plot.}

\item{label}{a string to identify the snapshot (alpha-numeric, hyphens, or underscores). Each plot in the test suite must have a unique label.}

\item{width}{of the snapshot. PNG default: 480 pixels. SVG default: 7 inches.}

\item{height}{of the snapshot. PNG default: 480 pixels. SVG default: 7 inches.}

\item{tol}{distance estimates larger than this threshold will trigger a test failure. Scale depends on the \code{metric} argument. With the default \code{metric="AE"} (absolute error), the \code{tolerance} corresponds roughly to the number of pixels of difference between the plot and the reference image.}

\item{metric}{string with a metric from \code{magick::metric_types()} such as \code{"AE"} or \code{"phash"}.}

\item{fuzz}{relative color distance between 0 and 100 to be considered similar.}

\item{device}{"svg", "png", "ragg" or "svglite"}

\item{device_args}{list of arguments to pass to the device call (e.g., \code{user_fonts} for \code{svglite} device).}

\item{par_args}{named list of arguments to pass to \code{graphics::par()} for setting graphical parameters. Only used when \code{device} is "png" or "ragg". Default is \code{NULL}.}

\item{theme}{a \code{ggplot2} theme function. \code{NULL} (default) uses \code{ggplot2::theme_test()}.}

\item{style}{A character vector to control the panels of the diff image saved to file. The order and number of entries controls the side-by-side panels. Allowable values are: "old", "new", "diff".}

\item{review}{logical. TRUE if a a diff plot should be saved to file for review when the expectation fails.}

\item{os}{character vector of operating systems on which the test should be run (e.g., "Windows", "Linux", "Darwin"). Tests are skipped when no element of the vector matches the output of: \code{Sys.info()["sysname"]}}

\item{skip}{logical. If TRUE, the test is skipped (with a message). Default: TRUE when the session is not interactive and neither the \code{NOT_CRAN} nor the \code{R_COVR} environment variable is set to "true".}

\item{info}{a string with user-supplied context shown when the test fails, prepended to the internal message.}
}
\value{
A \code{tinytest} object. A \code{tinytest} object is a \code{logical} with attributes holding information about the test that was run
}
\description{
This expectation can be used with \code{tinytest} to check if the new plot matches
a target plot.

When the expectation is checked for the first time, the expectation fails and
a reference plot is saved to the \verb{inst/tinytest/_tinysnapshot} folder.

When the expectation fails, the reference plot, the new plot, and a diff are
saved to the \code{inst/tinytest/label} folder. Call the \code{review()} function to compare.

To update a snapshot, delete the reference file from the \verb{_tinysnapshot}
folder and run the test suite again.

See the package README file or website for detailed examples.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/expect_snapshot_plot.R
\name{expect_equivalent_images}
\alias{expect_equivalent_images}
\title{Test if two image files are equivalent}
\usage{
expect_equivalent_images(
  current,
  target,
  tol = getOption("tinysnapshot_tol", default = 0),
  metric = getOption("tinysnapshot_metric", default = "AE"),
  fuzz = getOption("tinysnapshot_fuzz", default = 0),
  style = getOption("tinysnapshot_plot_diff_style", default = c("old", "new", "diff")),
  review = getOption("tinysnapshot_plot_review", default = TRUE),
  diffpath = NULL
)
}
\arguments{
\item{current}{path to an image file}

\item{target}{path to an image file}

\item{tol}{distance estimates larger than this threshold will trigger a test failure. Scale depends on the \code{metric} argument. With the default \code{metric="AE"} (absolute error), the \code{tolerance} corresponds roughly to the number of pixels of difference between the plot and the reference image.}

\item{metric}{string with a metric from \code{magick::metric_types()} such as \code{"AE"} or \code{"phash"}.}

\item{fuzz}{relative color distance between 0 and 100 to be considered similar.}

\item{style}{A character vector to control the panels of the diff image saved to file. The order and number of entries controls the side-by-side panels. Allowable values are: "old", "new", "diff".}

\item{review}{logical. TRUE if a a diff plot should be saved to file for review when the expectation fails.}

\item{diffpath}{path where to save an image which shows the differences between \code{current} and \code{target}. \code{NULL} means that the diff image is not saved.}
}
\value{
A \code{tinytest} object. A \code{tinytest} object is a \code{logical} with attributes holding information about the test that was run
}
\description{
Test if two image files are equivalent
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/expect_snapshot_print.R
\name{expect_snapshot_print}
\alias{expect_snapshot_print}
\title{Test if printed output matches a target printout}
\usage{
expect_snapshot_print(
  current,
  label,
  info = NULL,
  mode = getOption("tinysnapshot_mode", default = "unified"),
  format = getOption("tinysnapshot_format", default = "ansi256"),
  ignore_white_space = getOption("tinysnapshot_ignore_white_space", default = FALSE),
  fn_current = getOption("tinysnapshot_fn_current", default = identity),
  fn_target = getOption("tinysnapshot_fn_target", default = identity),
  ...
)
}
\arguments{
\item{current}{an object which returns text to the console when calling \verb{print(x})`}

\item{label}{a string to identify the snapshot (alpha-numeric, hyphens, or underscores). Each plot in the test suite must have a unique label.}

\item{info}{a string with user-supplied context shown when the test fails, prepended to the internal message.}

\item{mode}{"unified", "sidebyside", "context", or "auto". See \code{?diffobj::diffPrint}}

\item{format}{"raw", "ansi8", "ansi256", "html", or "auto". See \code{?diffobj::diffPrint}}

\item{ignore_white_space}{\code{TRUE} to ignore horizontal white space and empty lines.}

\item{fn_current}{A function to apply to the current output before comparison.}

\item{fn_target}{A function to apply to the target output before comparison.}

\item{...}{Additional arguments are passed to \code{diffobj::diffPrint()}}
}
\value{
A \code{tinytest} object. A \code{tinytest} object is a \code{logical} with attributes holding information about the test that was run
}
\description{
This expectation can be used with \code{tinytest} to check if the new plot matches
a target plot.

When the expectation is checked for the first time, the expectation fails and
a reference text file is saved to the \verb{inst/tinytest/_tinysnapshot} folder.

To update a snapshot, delete the reference file from the \verb{_tinysnapshot}
folder and run the test suite again.

See the package README file or website for detailed examples.
}

\name{tinysnapshot-package}
\alias{tinysnapshot-package}
\alias{tinysnapshot}
\docType{package}
\title{\packageTitle{tinysnapshot}}
\description{\packageDescription{tinysnapshot}}
\section{Package Content}{\packageIndices{tinysnapshot}}
\author{\packageAuthor{tinysnapshot}}
\section{Maintainer}{\packageMaintainer{tinysnapshot}}
\keyword{package}
